{*******************************************************}
{                                                       }
{       The Egg                                         }
{       Delphi 3 sample to make interface for a class   }
{       Paul Sitkei, sitkei@elender.hu                  }
{                                                       }
{*******************************************************}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons;

type
  TForm1 = class(TForm)
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    List: tList;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses Unit2, Unit3;

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
begin
  List:= TList.Create;
  Randomize;
  for i:= 0 to 10 do
    List.Add(TEgg.Create(Random(ClientWidth- 120), Random(ClientHeight- 80),
                         Rgb(Random(255), Random(255), Random(255))));
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i: Integer;
begin
  for i:= 0 to List.Count- 1 do
    TEgg(List.Items[i]).Free;
  List.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
var i: Integer;
begin
  for i:= 0 to List.Count- 1 do
    if SpeedButton1.Down
      then TSolid(List.Items[i]).Paint(Canvas)
      else TWired(List.Items[i]).Paint(Canvas);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Refresh;
end;

end.
