{*******************************************************}
{                                                       }
{       The Egg                                         }
{       Delphi 3 sample to make interface for a class   }
{       Paul Sitkei, sitkei@elender.hu                  }
{                                                       }
{*******************************************************}

unit Unit2;

interface

uses Graphics, Windows, Unit3;

type
  IPaint = interface
    procedure Paint(Canvas: TCanvas);
  end;

  TSolid = class(TEgg, IPaint)
    procedure Paint(Canvas: TCanvas);
    function QueryInterface(const IID: TGUID; out Obj): Integer; stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  end;

  TWired = class(TEgg, IPaint)
    procedure Paint(Canvas: TCanvas);
    function QueryInterface(const IID: TGUID; out Obj): Integer; stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  end;

implementation

procedure TSolid.Paint(Canvas: TCanvas);
begin
  with Canvas do
  begin
    Brush.Color:= Color;
    Ellipse(Left, Top, Left+ Width, Top+ Height);
  end;
end;

function TSolid.QueryInterface(const IID: TGUID; out Obj): Integer; begin end;
function TSolid._AddRef: Integer; begin end;
function TSolid._Release: Integer; begin end;

procedure TWired.Paint(Canvas: TCanvas);
begin
  with Canvas do
  begin
    Brush.Style:= bsClear;
    Ellipse(Left, Top, Left+ Width, Top+ Height);
  end;
end;

function TWired.QueryInterface(const IID: TGUID; out Obj): Integer; begin end;
function TWired._AddRef: Integer; begin end;
function TWired._Release: Integer; begin end;

end.
